
# DE by sex and LC 

## L1 
celltypes = unique(obj@meta.data$predicted.celltype.l1)

### Females
for(celltypei in celltypes){ 
  print(celltypei)
  filt = obj$predicted.celltype.l1 == celltypei & obj$Sex == "Female" & obj$Demuxlet_DropletType == "singlet" & metadata$percent.mt < 5
  temp = obj[,filt]
  outfile=paste0("wilcox_female_DE_",celltypei,".Rdata")
  if(!file.exists(outfile)){  
     test = FindMarkers(temp, ident.1="No", ident.2="Yes", logfc.threshold=0, test.use="wilcox", group.by="long.COVID")
      save(test, file = outfile )
   } 
}

### Males 
for(celltypei in celltypes){ 
  print(celltypei)
  filt = obj$predicted.celltype.l1 == celltypei & obj$Sex == "Male" & obj$Demuxlet_DropletType == "singlet" & metadata$percent.mt < 5
  temp = obj[,filt]
  outfile=paste0("wilcox_male_DE_",celltypei,".Rdata")
  if(!file.exists(outfile)){  
      test = FindMarkers(temp, ident.1="No", ident.2="Yes", logfc.threshold=0, test.use="wilcox", group.by="long.COVID")
  
      save(test, file = outfile )
   } 
}

### Joint 
for(celltypei in celltypes){ 
  print(celltypei)
  filt = obj$predicted.celltype.l1 == celltypei  & obj$Demuxlet_DropletType == "singlet" & metadata$percent.mt < 5
  temp = obj[,filt]
  outfile=paste0("wilcox_joint_DE_",celltypei,".Rdata")
   if(!file.exists(outfile)){  
      test = FindMarkers(temp, ident.1="No", ident.2="Yes", logfc.threshold=0, test.use="wilcox", group.by="long.COVID")
  
      save(test, file = outfile )
    } 
}



## L2 
freq = plyr::count(obj@meta.data$predicted.celltype.l2)
o = order(freq[,2])
celltypes = freq[rev(o),1]

### Females
for(celltypei in celltypes){ 
  print(celltypei)
  filt = obj$predicted.celltype.l2 == celltypei & obj$Sex == "Female" & obj$Demuxlet_DropletType == "singlet"  & metadata$percent.mt < 5
  temp = obj[,filt]
  outfile=paste0("wilcox_female_DE_l2_",celltypei,".Rdata")
  if(!file.exists(outfile)){  
      test = FindMarkers(temp, ident.1="No", ident.2="Yes", logfc.threshold=0, test.use="wilcox", group.by="long.COVID")
  
      save(test, file = outfile )
   } 
}

### Males 
for(celltypei in celltypes){ 
  print(celltypei)
  filt = obj$predicted.celltype.l2 == celltypei & obj$Sex == "Male" & obj$Demuxlet_DropletType == "singlet"  & metadata$percent.mt < 5
  temp = obj[,filt]
  outfile=paste0("wilcox_male_DE_l2_",celltypei,".Rdata")
    if(!file.exists(outfile)){  
      test = FindMarkers(temp, ident.1="No", ident.2="Yes", logfc.threshold=0, test.use="wilcox", group.by="long.COVID")
  
      save(test, file = outfile )
    } 
}

### Joint 
for(celltypei in celltypes){ 
  print(celltypei)
  filt = obj$predicted.celltype.l2 == celltypei   & obj$Demuxlet_DropletType == "singlet"   & metadata$percent.mt < 5
  temp = obj[,filt]
  outfile=paste0("wilcox_joint_DE_l2_",celltypei,".Rdata")
    if(!file.exists(outfile)){  
      test = FindMarkers(temp, ident.1="No", ident.2="Yes", logfc.threshold=0, test.use="wilcox", group.by="long.COVID")
  
      save(test, file = outfile )
    } 
}

