# Gene lists from Khoo et al paper, and other sources
isr = read.table("interferon_stimulated_response_genes_2011" )
ifns = read.table("interferons_hugo")
tcellse = read.table("tcellsexhaust")
cd8e = read.table( "cd8exhaust_khoo")
tsem = read.table("tsem_khoo")
ifnk = read.table("ifn_khoo")
cd8cyto = read.table("cd8cyto_khoo")

 
# Calculate scores based on gene lists  
obj@active.assay = "RNA"

obj <- AddModuleScore(obj,
                  features =  (cd8cyto),
                  name="cd8cyto_rna")


obj <- AddModuleScore(obj,
                  features =  (ifnk),
                  name="ifnk_rna")


obj <- AddModuleScore(obj,
                  features =  (tsem),
                  name="tsem_rna")

obj <- AddModuleScore(obj,
                  features =  (isr),
                  name="isr_rna")

obj <- AddModuleScore(obj,
                  features =  (ifns),
                  name="ifns_rna")

obj <- AddModuleScore(obj,
                  features =  (cd8e),
                  name="cd8e_rna")

obj <- AddModuleScore(obj,
                  features =  (tcellse),
                  name="tcellse_rna")



obj@active.assay = "SCT"

obj <- AddModuleScore(obj,
                  features =  (cd8cyto),
                  name="cd8cyto_sct")


obj <- AddModuleScore(obj,
                  features =  (ifnk),
                  name="ifnk_sct")


obj <- AddModuleScore(obj,
                  features =  (tsem),
                  name="tsem_sct")

obj <- AddModuleScore(obj,
                  features =  (isr),
                  name="isr_sct")

obj <- AddModuleScore(obj,
                  features =  (ifns),
                  name="ifns_sct")

obj <- AddModuleScore(obj,
                  features =  (cd8e),
                  name="cd8e_sct")

obj <- AddModuleScore(obj,
                  features =  (tcellse),
                  name="tcellse_sct")

 
