#### EDITING NOT FINALISED #### 

gois = c("PDCD1","HAVCR2", "TIGIT", "KLRG1", "B3GAT1")

# Load data 
load("../../phens/metadata.Rdata")
load("predicted.metadata_noVDJ.Rdata") 
obj = readRDS("combined_all_SCT.rds")

# Remove VDJ genes 
countmatrix = obj@assays$RNA@counts
is_ig_vdj <- grepl("IG[HLK][VJ]", row.names(countmatrix))
is_ighd_vdj <- grepl("IGHD.-", row.names(countmatrix)) #so as to not drop IGHD constant regions
is_tr_vdj <- grepl("^TR[ABGD][VDJ]", row.names(countmatrix)) 
countmatrix_noVDJ <- countmatrix[!(is_tr_vdj | is_ighd_vdj | is_ig_vdj),]
seurat_obj_noVDJ <- CreateSeuratObject(counts=countmatrix_noVDJ, assay="RNA")
seurat_obj_noVDJ <- SCTransform(seurat_obj_noVDJ, verbose=TRUE)
seurat_obj_noVDJ <- RunPCA(seurat_obj_noVDJ)
saveRDS(seurat_obj_noVDJ, file = "combined_all_SCT_noVDJ.rds")
 
# Filter bad cells 
filt1 = metadata$Demuxlet_DropletType == "singlet" & metadata$percent.mt < 5
metadata$filt = filt1 
save(metadata, file="final_metadata.Rdata")
 
# Create filters   
filt_t24 = metadata$timepoint == "24months" 
filt_t4 = metadata$timepoint == "4months" 
filt_t8 = metadata$timepoint == "8months" 

filt_myl = grepl("CD14|CD16|pDC|cDC|ASDC", metadata$predicted.celltype.l2) 
filt_tcells = grepl("CD8|CD4|MAIT|Treg", metadata$predicted.celltype.l2) 
filt_naive = grepl("Naive|naive", metadata$predicted.celltype.l2) 
filt_ext = grepl("B|CD4|CD8|NK", metadata$predicted.celltype.l1)

filt1 = metadata$filt 

# T cells 
xlab="Cell type"
ylab="CD8 exhaust"
col_lc = c("red", "blue")
par(mfrow=c(3,1))
filt = filt1 & filt_tcells & filt_t4
boxplot( metadata$cd8e_sct1[filt] ~ metadata$long.COVID[filt] + metadata$predicted.celltype.l2[filt]  , main="4 months", col=col_lc , ylab=ylab, xlab=xlab)  
filt = filt1 & filt_tcells & filt_t8
boxplot( metadata$cd8e_sct1[filt] ~ metadata$long.COVID[filt] + metadata$predicted.celltype.l2[filt]  , main="8 months", col=col_lc , ylab=ylab, xlab=xlab)   
filt = filt1 & filt_tcells & filt_t24
boxplot( metadata$cd8e_sct1[filt] ~ metadata$long.COVID[filt] + metadata$predicted.celltype.l2[filt]  , main="24 months", col=col_lc , ylab=ylab, xlab=xlab)  

# Myloid cells 
xlab="Cell type"
ylab ="IFN scores"
par(mfrow=c(3,1))
filt = filt1 & filt_myl & filt_t4
boxplot( metadata$ifnk_sct1[filt] ~ metadata$long.COVID[filt] + metadata$predicted.celltype.l2[filt]  , main="4 months", col=col_lc , ylab=ylab, xlab=xlab)  
filt = filt1 & filt_myl & filt_t8
boxplot( metadata$ifnk_sct1[filt] ~ metadata$long.COVID[filt] + metadata$predicted.celltype.l2[filt]  , main="8 months", col=col_lc , ylab=ylab, xlab=xlab)   
filt = filt1 & filt_myl & filt_t24
boxplot( metadata$ifnk_sct1[filt] ~ metadata$long.COVID[filt] + metadata$predicted.celltype.l2[filt]  , main="24 months", col=col_lc , ylab=ylab, xlab=xlab)  

# All cells 
xlab="Cell type"
par(mfrow=c(3,1))
ylab ="IFN scores"
filt = filt1  & filt_t4
boxplot( metadata$ifnk_sct1[filt] ~ metadata$long.COVID[filt] + metadata$predicted.celltype.l2[filt]  , main="4 months", col=col_lc , ylab=ylab, xlab=xlab)  
filt = filt1 &  filt_t8
boxplot( metadata$ifnk_sct1[filt] ~ metadata$long.COVID[filt] + metadata$predicted.celltype.l2[filt]  , main="8 months", col=col_lc , ylab=ylab, xlab=xlab)   
filt = filt1 &  filt_t24
boxplot( metadata$ifnk_sct1[filt] ~ metadata$long.COVID[filt] + metadata$predicted.celltype.l2[filt]  , main="24 months", col=col_lc , ylab=ylab, xlab=xlab)  


xlab="Cell type"
ylab ="IFN scores"
yrange = c(-0.15,0.65) 

par(mfrow=c(3,2))
filt = filt1 & filt_myl & filt_t4
boxplot( metadata$ifnk_sct1[filt] ~ metadata$long.COVID[filt] + metadata$predicted.celltype.l2[filt]  , main="4 months", ylim=yrange, col=col_lc , ylab=ylab, xlab=xlab)
filt = filt1 & filt_ext & filt_t4
boxplot( metadata$ifnk_sct1[filt] ~ metadata$long.COVID[filt] + metadata$predicted.celltype.l1[filt]  , main="4 months",ylim=yrange,  col=col_lc , ylab=ylab, xlab=xlab)  

filt = filt1 & filt_myl & filt_t8
boxplot( metadata$ifnk_sct1[filt] ~ metadata$long.COVID[filt] + metadata$predicted.celltype.l2[filt]  , main="8 months",ylim=yrange,  col=col_lc , ylab=ylab, xlab=xlab)   
filt = filt1 & filt_ext & filt_t8
boxplot( metadata$ifnk_sct1[filt] ~ metadata$long.COVID[filt] + metadata$predicted.celltype.l1[filt]  , main="8 months", ylim=yrange, col=col_lc , ylab=ylab, xlab=xlab)   


filt = filt1 & filt_myl & filt_t24
boxplot( metadata$ifnk_sct1[filt] ~ metadata$long.COVID[filt] + metadata$predicted.celltype.l2[filt]  , main="24 months",ylim=yrange,  col=col_lc , ylab=ylab, xlab=xlab)  
filt = filt1 & filt_ext & filt_t24
boxplot( metadata$ifnk_sct1[filt] ~ metadata$long.COVID[filt] + metadata$predicted.celltype.l1[filt]  , main="24 months",ylim=yrange,  col=col_lc , ylab=ylab, xlab=xlab)  




# Interferon scores again
celltypes = unique(metadata$predicted.celltype.l2)
metadata$timepoint = factor(metadata$timepoint, levels=c("4months", "8months", "24months")) 
par(mfrow=c(4,6))
for( ci in celltypes){ 
  filt_cell = metadata$predicted.celltype.l2 == ci 
  filt = filt1 & filt_cell 
  boxplot( metadata$ifnk_sct1[filt] ~ metadata$long.COVID[filt] + metadata$timepoint[filt]  , main=ci, col=col_lc , ylab=ylab, xlab=xlab)  
}
par(mfrow=c(4,6))
for( ci in celltypes){ 
  filt_cell = metadata$predicted.celltype.l2 == ci 
  filt = filt1 & filt_cell 
  boxplot( metadata$isr_sct1[filt] ~ metadata$long.COVID[filt] + metadata$timepoint[filt]  , main=ci, col=col_lc , ylab=ylab, xlab=xlab)  
}
par(mfrow=c(4,6))
for( ci in celltypes){ 
  filt_cell = metadata$predicted.celltype.l2 == ci 
  filt = filt1 & filt_cell 
  boxplot( metadata$ifns_sct1[filt] ~ metadata$long.COVID[filt] + metadata$timepoint[filt]  , main=ci, col=col_lc , ylab=ylab, xlab=xlab)  
}

 

# PLot UMAP removing VDJ genes  
seurat_obj_noVDJ = RunPCA(seurat_obj_noVDJ )
seurat_obj_noVDJ = RunUMAP(seurat_obj_noVDJ,    dims = 1:30)
seurat_obj_noVDJ = RunTSNE(seurat_obj_noVDJ,    dims = 1:30)
seurat_obj_noVDJ <- FindNeighbors(seurat_obj_noVDJ, dims = 1:30, verbose = FALSE)
seurat_obj_noVDJ <- FindClusters(seurat_obj_noVDJ, resolution = 0.5)
 
 
#plot the umap
png("plots/seurat_obj_noVDJ.png", width=1000, height=1000)
DimPlot(object = seurat_obj_noVDJ, reduction = 'umap', pt.size=2) 
dev.off() 

# Plot naive cells 
naivecells <- subset(seurat_obj_noVDJ[,filt1 & filt2], predicted.celltype.l2 == "B naive" | predicted.celltype.l2 == "CD4 Naive" |  predicted.celltype.l2 == "CD8 Naive")
countmatrix = naivecells@assays$integrated@data
countmatrix2 = naivecells@assays$integrated@scale.data

is_ig_vdj <- grepl("IG[HLK][VJ]", row.names(countmatrix))
is_ighd_vdj <- grepl("IGHD.-", row.names(countmatrix)) #so as to not drop IGHD constant regions
is_tr_vdj <- grepl("^TR[ABGD][VDJ]", row.names(countmatrix)) 

## Zeroing the IG/TR VDJ genes from the count matrix
naivecells@assays$integrated@scale.data[(is_tr_vdj | is_ighd_vdj | is_ig_vdj), ] = 0
naivecells@assays$integrated@data[(is_tr_vdj | is_ighd_vdj | is_ig_vdj), ] = 0
 
# Run dim reduction and clustering 
naivecells <- RunPCA(naivecells, verbose = FALSE)
naivecells <- RunUMAP(naivecells, reduction = "pca", dims = 1:15)
naivecells <- FindNeighbors(naivecells, reduction = "pca", dims = 1:15)
naivecells <- FindClusters(naivecells, resolution = 0.5)

png("plots/naive_cells_noVDJ.l2.png",  width=1000, height=1000)
DimPlot(naivecells, reduction = "umap", label = TRUE, repel = TRUE, group.by="predicted.celltype.l2", pt.size=2)
dev.off()

t24 = naivecells$timepoint == "24months"
t4 = naivecells$timepoint == "4months"
t8 = naivecells$timepoint == "8months"

png("plots/naive_cells_noVDJ.splitlc_t24.png",  width=2000, height=1000)
DimPlot(naivecells[,t24], reduction = "umap", label = TRUE, repel = TRUE,group.by="predicted.celltype.l2", split.by="long.COVID", pt.size=2 ) + plot_annotation(title="24 months")
dev.off()
 
png("plots/naive_cells_noVDJ.splitlc_t8.png",  width=2000, height=1000)
DimPlot(naivecells[,t4], reduction = "umap", label = TRUE, repel = TRUE,group.by="predicted.celltype.l2", split.by="long.COVID", pt.size=2 )+ plot_annotation(title="8 months")
dev.off()

 
png("plots/naive_cells_noVDJ.splitlc_t4.png",  width=2000, height=1000)
DimPlot(naivecells[,t8], reduction = "umap", label = TRUE, repel = TRUE,group.by="predicted.celltype.l2", split.by="long.COVID", pt.size=2) + plot_annotation(title="4 months")
dev.off()
 

png("plots/naive_cells_noVDJ.splitlc_timepoint.png",  width=2000, height=1000)
DimPlot(naivecells, reduction = "umap", label = TRUE, repel = TRUE,group.by="timepoint", split.by="long.COVID", pt.size=2) + plot_annotation(title="4 months")
dev.off()
 
  
# Version 2 (removing VDJ)
naivecells2 = naivecells
naivecells2@assays$integrated@scale.data = countmatrix2[!(is_tr_vdj | is_ighd_vdj | is_ig_vdj),]
naivecells2@assays$integrated@data = countmatrix[!(is_tr_vdj | is_ighd_vdj | is_ig_vdj),]


# Run dim reduction and clustering 
naivecells2 <- RunPCA(naivecells2, verbose = FALSE)
naivecells2 <- RunUMAP(naivecells2, reduction = "pca", dims = 1:15)
naivecells2 <- FindNeighbors(naivecells2, reduction = "pca", dims = 1:15)
naivecells2 <- FindClusters(naivecells2, resolution = 0.5)


# Visualizations

## UMAP
p1 <- DimPlot(naivecells2, reduction = "umap", group.by = "timepoint")
p2 <- DimPlot(naivecells2, reduction = "umap", group.by = "predicted.celltype.l2", label = TRUE, repel = TRUE)
p3 <- DimPlot(naivecells2, reduction = "umap", group.by = "batch")
p4 <- DimPlot(naivecells2, reduction = "umap", group.by = "long.COVID", label = TRUE, repel = TRUE)


png("plots/combined_SCT_naivecells_removedvdj2.png",  width=1000)
p1 + p2
dev.off()

png("plots/combined_SCT_naivecells2_split.png",  width=2000, height=1000)
DimPlot(naivecells2, reduction = "umap", label = TRUE, repel = TRUE,group.by="timepoint", split.by="long.COVID", pt.size=2) 
dev.off()

png("plots/combined_SCT_naivecells2_splitv2.png",  width=2000, height=1000)
DimPlot(naivecells2, reduction = "umap", label = TRUE, repel = TRUE,group.by="long.COVID", split.by="timepoint", pt.size=2) 
dev.off()

png("plots/combined_SCT_naivecells2_splitv3.png",  width=2000, height=1000)
DimPlot(naivecells2, reduction = "umap", label = TRUE, repel = TRUE,group.by="predicted.celltype.l2", split.by="timepoint", pt.size=2) 
dev.off()

png("plots/combined_SCT_naivecells2_splitv4.png",  width=2000, height=1000)
DimPlot(naivecells2, reduction = "umap", label = TRUE, repel = TRUE,group.by="predicted.celltype.l2", split.by="long.COVID", pt.size=2) 
dev.off()

png("plots/combined_SCT_naivecells2_l3.png",  width=1000, height=1000)
DimPlot(naivecells2, reduction = "umap", label = TRUE, repel = TRUE,group.by="predicted.celltype.l3", pt.size=2) 
dev.off()

png("plots/combined_SCT_naivecells2_seurat.png",  width=1000, height=1000)
DimPlot(naivecells2, reduction = "umap", label = TRUE, repel = TRUE,  pt.size=2) 
dev.off()


 

## Extracting pvalues of scores per timepoint 
scores_labels = colnames(metadata)[37:43]

filt_t24 = metadata$timepoint == "24months"
filt_t8 = metadata$timepoint == "8months"
filt_t4 = metadata$timepoint == "4months"
filtf = metadata$Sex == "Female"
filtm = metadata$Sex == "Male"


filts_list = list( 
 metadata$Demuxlet_DropletType == "singlet" & metadata$percent.mt < 5 & filt_t4,
 metadata$Demuxlet_DropletType == "singlet" & metadata$percent.mt < 5 & filt_t8,
 metadata$Demuxlet_DropletType == "singlet" & metadata$percent.mt < 5 & filt_t24,
 metadata$Demuxlet_DropletType == "singlet" & metadata$percent.mt < 5)
labels = c("t4", "t8", "t24", "tall") 

pvals_list_store = list() 
j = 1 
for(filt1 in filts_list){ 
   label = labels[j] 
   j = j + 1 
   
   pvals_list = list() 
   for(scorej in scores_labels){
       print(scorej)
       joint_test = list() 
       female_test = list() 
       male_test = list() 
       celltypes = unique( metadata$predicted.celltype.l2) 
       for(i in celltypes ){ 
         print(i)
         filt = metadata$predicted.celltype.l2 == i  & filt1 
    
         if( length(unique(metadata$long.COVID[filt])) > 1 ) { 
             joint_test[[i]] = wilcox.test( metadata[,scorej][filt] ~ metadata$long.COVID[filt])$p.val
          } else { joint_test[[i]] = NA }
         if( length(unique(metadata$long.COVID[filt&filtf])) > 1 ) { 
             female_test[[i]] =  wilcox.test( metadata[,scorej][filt&filtf] ~ metadata$long.COVID[filt&filtf])$p.val
          } else { female_test[[i]] = NA }
         if( length(unique(metadata$long.COVID[filt&filtm])) > 1 ) { 
             male_test[[i]] =  wilcox.test( metadata[,scorej][filt&filtm] ~ metadata$long.COVID[filt&filtm])$p.val
          } else { male_test[[i]] = NA }
       } 
       
       pvals_l2 = cbind(do.call(rbind, joint_test),do.call(rbind, female_test),do.call(rbind, male_test))
       padj_l2 = apply(pvals_l2, 2, p.adjust )
       colnames(pvals_l2) = c("joint", "female", "male")
       colnames(padj_l2) = c("joint", "female", "male")
       
       
       joint_test = list() 
       female_test = list() 
       male_test = list() 
       celltypes = unique( metadata$predicted.celltype.l1) 
       for(i in celltypes ){ 
         print(i)
         filt = metadata$predicted.celltype.l1 == i  & filt1 
    
         if( length(unique(metadata$long.COVID[filt])) > 1 ) { 
             joint_test[[i]] = wilcox.test( metadata[,scorej][filt] ~ metadata$long.COVID[filt])$p.val
          } else { joint_test[[i]] = NA }
         if( length(unique(metadata$long.COVID[filt&filtf])) > 1 ) { 
             female_test[[i]] =  wilcox.test( metadata[,scorej][filt&filtf] ~ metadata$long.COVID[filt&filtf])$p.val
          } else { female_test[[i]] = NA }
         if( length(unique(metadata$long.COVID[filt&filtm])) > 1 ) { 
             male_test[[i]] =  wilcox.test( metadata[,scorej][filt&filtm] ~ metadata$long.COVID[filt&filtm])$p.val
          } else { male_test[[i]] = NA }
       } 
       
       pvals_l1 = cbind(do.call(rbind, joint_test),do.call(rbind, female_test),do.call(rbind, male_test))
       padj_l1 = apply(pvals_l1, 2, p.adjust )
       colnames(pvals_l1) = c("joint", "female", "male")
       colnames(padj_l1) = c("joint", "female", "male")
       pvals_list[[scorej]] = rbind(cbind( pvals_l1, padj_l1), cbind( pvals_l2, padj_l2))
   }
   pvals_list_store[[label]] = pvals_list 
} 
save(pvals_list_store, labels, filts_list,  file="pvals_scores.Rdata")



## Extracting means of scores per timepoint 
means_list_store = list() 
j = 1 
for(filt1 in filts_list){ 
   label = labels[j] 
   j = j + 1 
   
   mean_list = list() 
   for(scorej in scores_labels){
       print(scorej)
       joint_test = list() 
       female_test = list() 
       male_test = list() 
       celltypes = unique( metadata$predicted.celltype.l2) 
       for(i in celltypes ){ 
         print(i)
         filt = metadata$predicted.celltype.l2 == i  & filt1 
   
         if( length(unique(metadata$long.COVID[filt])) > 1 ) { 
             joint_test[[i]]  = tapply( metadata[,scorej][filt], metadata$long.COVID[filt], mean)
          } else { joint_test[[i]] = c(NA,NA) }
         if( length(unique(metadata$long.COVID[filt&filtf])) > 1 ) { 
             female_test[[i]] = tapply( metadata[,scorej][filt&filtf], metadata$long.COVID[filt&filtf], mean)
          } else { female_test[[i]] = c(NA,NA) }
         if( length(unique(metadata$long.COVID[filt&filtm])) > 1 ) { 
             male_test[[i]]   = tapply( metadata[,scorej][filt&filtm], metadata$long.COVID[filt&filtm], mean)
          } else { male_test[[i]] = c(NA,NA) }
    
       } 
       
       mean_l2 = cbind(do.call(rbind, joint_test),do.call(rbind, female_test),do.call(rbind, male_test))
       
       colnames(pvals_l2) = c("joint", "female", "male")
       colnames(padj_l2) = c("joint", "female", "male")
       
       
       joint_test = list() 
       female_test = list() 
       male_test = list() 
       celltypes = unique( metadata$predicted.celltype.l1) 
       for(i in celltypes ){ 
         print(i)
         filt = metadata$predicted.celltype.l1 == i  & filt1 
   
         if( length(unique(metadata$long.COVID[filt])) > 1 ) { 
             joint_test[[i]]  = tapply( metadata[,scorej][filt], metadata$long.COVID[filt], mean)
          } else { joint_test[[i]] = c(NA,NA) }
         if( length(unique(metadata$long.COVID[filt&filtf])) > 1 ) { 
             female_test[[i]] = tapply( metadata[,scorej][filt&filtf], metadata$long.COVID[filt&filtf], mean)
          } else { female_test[[i]] = c(NA,NA) }
         if( length(unique(metadata$long.COVID[filt&filtm])) > 1 ) { 
             male_test[[i]]   = tapply( metadata[,scorej][filt&filtm], metadata$long.COVID[filt&filtm], mean)
          } else { male_test[[i]] = c(NA,NA) }
    
   
       } 
       
       mean_l1 = cbind(do.call(rbind, joint_test),do.call(rbind, female_test),do.call(rbind, male_test))
       mean_list[[scorej]] = rbind( mean_l1, mean_l2 )
   }
means_list_store[[label]] =  mean_list
}
 
save(means_list_store,labels, filts_list,  file="means_scores.Rdata")


## Extract percent scores per timepoint 
features_scores = list(isr,ifns,tcellse, cd8e,tsem,ifnk, cd8cyto   ) 
scores_labels2 = c("isr","ifns","tcellse", "cd8e","tsem","ifnk", "cd8cyto"   ) 

obj@active.assay = "RNA"
filt_t24 = obj@meta.data$timepoint == "24months"
filt_t8 = obj@meta.data$timepoint == "8months"
filt_t4 = obj@meta.data$timepoint == "4months"
filtf = obj@meta.data$Sex == "Female"
filtm = obj@meta.data$Sex == "Male"
filtnone = filtf|filtm 
filts_list = c()
dp_list_store = list(filt_t4,filt_t8,filt_t24, filtnone ) 
k = 1 
for(filt in filts_list){ 
   label = labels[k] 
   k = k + 1 
   j = 1 
    for(feature in features_scores ){
      scorej = scores_labels2[j]  
      dp_l1 = DotPlot(obj[,filt], features=feature, split.by = "long.COVID", group.by = "predicted.celltype.l1")$data
        dp_f_l1 = DotPlot(obj[,filt&filtf], features=feature, split.by = "long.COVID", group.by = "predicted.celltype.l1")$data
        dp_m_l1 = DotPlot(obj[,filt&filtm], features=feature, split.by = "long.COVID", group.by = "predicted.celltype.l1")$data
      
        dp_l2 = DotPlot(obj[,filt], features=feature, split.by = "long.COVID", group.by = "predicted.celltype.l2")$data
        dp_f_l2 = DotPlot(obj[,filt&filtf], features=feature, split.by = "long.COVID", group.by = "predicted.celltype.l2")$data
        dp_m_l2 = DotPlot(obj[,filt&filtm], features=feature, split.by = "long.COVID", group.by = "predicted.celltype.l2")$data
        
       dp_list[[scorej]]  =   list( tapply( dp_l1$pct.exp, dp_l1$id, mean), 
              tapply( dp_f_l1$pct.exp, dp_f_l1$id, mean), 
              tapply( dp_m_l1$pct.exp, dp_m_l1$id, mean), 
              tapply( dp_l2$pct.exp, dp_l2$id, mean), 
              tapply( dp_f_l2$pct.exp, dp_f_l2$id, mean),
              tapply( dp_m_l2$pct.exp, dp_m_l2$id, mean))
        
        j = j + 1 
        
    }
     dp_list_store[[label]] = dp_list 
     
} 
save(dp_list_store,labels, features_scores, filts_list,  file="pct_exp_scores.Rdata")


dp_list_t24_mod = list() 
for(i in 1:7) { 
    temp = dp_list_t24[[i]][1:3]
    names(temp) =  c("joint", "female", "male")
    temp2 = names(unlist(temp))
    temp2 = do.call(rbind, strsplit(temp2, "\\.") )
    
    temp2[,2] = gsub("_Yes", "__Yes", temp2[,2])
    temp2[,2] = gsub("_No", "__No", temp2[,2])
    temp3 = do.call(rbind, strsplit(temp2[,2], "__") )
    df = as.data.frame(cbind(temp2[,1] , temp3, unlist(temp)) )
    
    
    temp_l1 = t(spread(df, key=2, value = 4 )) 
    
    
    
    temp = dp_list_t24[[i]][4:6]
    names(temp) =  c("joint", "female", "male")
    temp2 = names(unlist(temp))
    temp2 = do.call(rbind, strsplit(temp2, "\\.") )
    
    temp2[,2] = gsub("_Yes", "__Yes", temp2[,2])
    temp2[,2] = gsub("_No", "__No", temp2[,2])
    temp3 = do.call(rbind, strsplit(temp2[,2], "__") )
    df = as.data.frame(cbind(temp2[,1] , temp3, unlist(temp)) )
    
    
    temp_l2 = t(spread(df, key=2, value = 4 )) 

    dp_list_t24_mod[[i]] = rbind(temp_l1, temp_l2)
} 
names(dp_list_t24_mod) = names(dp_list_t24)





dp_list_t4_mod = list() 
for(i in 1:7) { 
    temp = dp_list_t4[[i]][1:3]
    names(temp) =  c("joint", "female", "male")
    temp2 = names(unlist(temp))
    temp2 = do.call(rbind, strsplit(temp2, "\\.") )
    
    temp2[,2] = gsub("_Yes", "__Yes", temp2[,2])
    temp2[,2] = gsub("_No", "__No", temp2[,2])
    temp3 = do.call(rbind, strsplit(temp2[,2], "__") )
    df = as.data.frame(cbind(temp2[,1] , temp3, unlist(temp)) )
    
    
    temp_l1 = t(spread(df, key=2, value = 4 )) 
    
    
    
    temp = dp_list_t4[[i]][4:6]
    names(temp) =  c("joint", "female", "male")
    temp2 = names(unlist(temp))
    temp2 = do.call(rbind, strsplit(temp2, "\\.") )
    
    temp2[,2] = gsub("_Yes", "__Yes", temp2[,2])
    temp2[,2] = gsub("_No", "__No", temp2[,2])
    temp3 = do.call(rbind, strsplit(temp2[,2], "__") )
    df = as.data.frame(cbind(temp2[,1] , temp3, unlist(temp)) )
    
    
    temp_l2 = t(spread(df, key=2, value = 4 )) 

    dp_list_t4_mod[[i]] = rbind(temp_l1, temp_l2)
} 
names(dp_list_t4_mod) = names(dp_list_t4)



dp_list_t8_mod = list() 
for(i in 1:7) { 
    temp = dp_list_t8[[i]][1:3]
    names(temp) =  c("joint", "female", "male")
    temp2 = names(unlist(temp))
    temp2 = do.call(rbind, strsplit(temp2, "\\.") )
    temp2[,2] = gsub("_Yes", "__Yes", temp2[,2])
    temp2[,2] = gsub("_No", "__No", temp2[,2])
    temp3 = do.call(rbind, strsplit(temp2[,2], "__") )
    df = as.data.frame(cbind(temp2[,1] , temp3, unlist(temp)) )
    temp_l1 = t(spread(df, key=2, value = 4 )) 
    
    
    
    temp = dp_list_t8[[i]][4:6]
    names(temp) =  c("joint", "female", "male")
    temp2 = names(unlist(temp))
    temp2 = do.call(rbind, strsplit(temp2, "\\.") )
    temp2[,2] = gsub("_Yes", "__Yes", temp2[,2])
    temp2[,2] = gsub("_No", "__No", temp2[,2])
    temp3 = do.call(rbind, strsplit(temp2[,2], "__") )
    df = as.data.frame(cbind(temp2[,1] , temp3, unlist(temp)) )
    
    
    temp_l2 = t(spread(df, key=2, value = 4 )) 

    dp_list_t8_mod[[i]] = rbind(temp_l1, temp_l2)
} 
names(dp_list_t8_mod) = names(dp_list_t8)




dp_list_all_mod = list() 
for(i in 1:7) { 
    temp = dp_list_all[[i]][1:3]
    names(temp) =  c("joint", "female", "male")
    temp2 = names(unlist(temp))
    temp2 = do.call(rbind, strsplit(temp2, "\\.") )
    temp2[,2] = gsub("_Yes", "__Yes", temp2[,2])
    temp2[,2] = gsub("_No", "__No", temp2[,2])
    temp3 = do.call(rbind, strsplit(temp2[,2], "__") )
    df = as.data.frame(cbind(temp2[,1] , temp3, unlist(temp)) )
    temp_l1 = t(spread(df, key=2, value = 4 )) 
    
    
    
    temp = dp_list_all[[i]][4:6]
    names(temp) =  c("joint", "female", "male")
    temp2 = names(unlist(temp))
    temp2 = do.call(rbind, strsplit(temp2, "\\.") )
    temp2[,2] = gsub("_Yes", "__Yes", temp2[,2])
    temp2[,2] = gsub("_No", "__No", temp2[,2])
    temp3 = do.call(rbind, strsplit(temp2[,2], "__") )
    df = as.data.frame(cbind(temp2[,1] , temp3, unlist(temp)) )
    
    
    temp_l2 = t(spread(df, key=2, value = 4 )) 

    dp_list_all_mod[[i]] = rbind(temp_l1, temp_l2)
} 
names(dp_list_all_mod) = names(dp_list_all)

save(dp_list_all_mod,dp_list_t8_mod,dp_list_t24_mod, dp_list_t4_mod,  file="pct_exp_scores_mod.Rdata")



# Write out 
write.csv(mean_list_store[["t8"]], file="means_t8.csv")
write.csv(mean_list_store[["t4"]], file="means_t4.csv")
write.csv(mean_list_store[["t24"]], file="means_t24.csv")
write.csv(pvals_list_store[["t24"]], file="pvals_t24.csv")
write.csv(pvals_list_store[["t4"]], file="pvals_t4.csv")
write.csv(pvals_list_store[["t8"]], file="pvals_t8.csv")
write.csv(dp_list_t24_mod, file="perc_t24.csv")
write.csv(dp_list_t4_mod, file="perc_t4.csv")
write.csv(dp_list_t8_mod, file="perc_t8.csv")

 
# Plots 
filt1 = metadata$filt 
df = plyr::count(cbind(metadata$predicted.celltype.l2[filt1], metadata$timepoint[filt1] ))
counts_time = spread(df, key=1, value=3)
fracs_time = sapply(2:29, function(i) counts_time[,i]/rowSums(counts_time[,-1] , na.rm=T) )
colnames(fracs_time) = colnames(counts_time)[2:29]
rownames(fracs_time) = counts_time[,1]
fracs_time[is.na(fracs_time)] = 0 

m = match(colnames(fracs_time), colpals$L2)
barplot( t(fracs_time[c(2,3,1),]) , col= colpals[m,3])

df = plyr::count(cbind(metadata$predicted.celltype.l2[filt1],  metadata$timepoint[filt1], metadata$long.COVID[filt1] ))
counts_time_1 = spread(df[df[,3]=="Yes",-3], key=1, value=3)
counts_time_2 = spread(df[df[,3]=="No",-3], key=1, value=3)
fracs_time_1 = sapply(2:29, function(i) counts_time_1[,i]/rowSums(counts_time_1[,-1] , na.rm=T) )
fracs_time_2 = sapply(2:28, function(i) counts_time_2[,i]/rowSums(counts_time_2[,-1] , na.rm=T) )

colnames(fracs_time_1) = colnames(counts_time_1)[2:29]
rownames(fracs_time_1) = counts_time_1[,1]
colnames(fracs_time_2) = colnames(counts_time_2)[2:28]
rownames(fracs_time_2) = counts_time_2[,1]


m = match(colnames(fracs_time_1), colnames(fracs_time_2))
fracs_time_2 = fracs_time_2[,m]
colnames(fracs_time_2) = colnames(fracs_time_1)
fracs_time_1[is.na(fracs_time_1)] = 0 
fracs_time_2[is.na(fracs_time_2)] = 0 
 
   
m = match(colnames(fracs_time), colpals$L2)
barplot( t(fracs_time_1[c(2,3,1),]) , col= colpals[m,3])
barplot( t(fracs_time_2[c(2,3,1),]) , col= colpals[m,3])
fracs_time_all = cbind(fracs_time_1[2,],fracs_time_2[2,], fracs_time_1[3,],fracs_time_2[3,], fracs_time_1[1,],fracs_time_2[1,] )
colnames(fracs_time_all) = paste( rep( c("Yes", "No"),3) ) 
colnames(fracs_time_all) = paste( colnames(fracs_time_all), unlist(lapply(c(2,3,1), function(i) rep(rownames(fracs_time_1)[i],2) )))
m = match(colnames(fracs_time), colpals$L2)
barplot(  fracs_time_all   , col= colpals[m,3])


                                                                          

### 
df = plyr::count(cbind(metadata$predicted.celltype.l2[filt1],  metadata$timepoint[filt1], metadata$long.COVID[filt1], metadata$Demuxlet_Individual_Assignment[filt1] ))
counts_time_4 = spread(df[df[,2]=="4months",-c(2,3)], key=1, value=3)
counts_time_8 = spread(df[df[,2]=="8months",-c(2,3)], key=1, value=3)
counts_time_24 = spread(df[df[,2]=="24months",-c(2,3)], key=1, value=3)
fracs_time_4 = sapply(2:27, function(i) counts_time_4[,i]/rowSums(counts_time_4[,-1] , na.rm=T) )
fracs_time_8 = sapply(2:28, function(i) counts_time_8[,i]/rowSums(counts_time_8[,-1] , na.rm=T) )
fracs_time_24 = sapply(2:29, function(i) counts_time_24[,i]/rowSums(counts_time_24[,-1] , na.rm=T) )


colnames(fracs_time_24) = colnames(counts_time_24)[2:29]
rownames(fracs_time_24) = counts_time_24[,1]

colnames(fracs_time_4) = colnames(counts_time_4)[2:27]
rownames(fracs_time_4) = counts_time_4[,1]

colnames(fracs_time_8) = colnames(counts_time_8)[2:28]
rownames(fracs_time_8) = counts_time_8[,1]


m = match(colnames(fracs_time_24), colnames(fracs_time_8))
fracs_time_8 = fracs_time_8[,m]
colnames(fracs_time_8) = colnames(fracs_time_24)

m = match(colnames(fracs_time_24), colnames(fracs_time_4))
fracs_time_4 = fracs_time_4[,m]
colnames(fracs_time_4) = colnames(fracs_time_24)


fracs_time_4[is.na(fracs_time_4)] = 0 
fracs_time_8[is.na(fracs_time_8)] = 0 
fracs_time_24[is.na(fracs_time_24)] = 0 
 

m = match(colnames(fracs_time_24), colpals$L2)
par(mfrow=c(3,1))
barplot( t(fracs_time_4) , col= colpals[m,3])
barplot( t(fracs_time_8) , col= colpals[m,3])
barplot( t(fracs_time_24) , col= colpals[m,3])

 
fracs_time_all_ind = rbind(fracs_time_4, fracs_time_8, fracs_time_24  )
rownames(fracs_time_all_ind) = c(paste(rownames(fracs_time_4), "4 months") ,
paste(rownames(fracs_time_8), "8 months"),
paste(rownames(fracs_time_24), "24 months"))

lc = unique(df[,3:4])
mm  = match(rownames(fracs_time_4), lc[,2] ) 
oo  = match(lc[,2], rownames(fracs_time_4) ) 


lc_all = rep( lc[mm,1], 3)

sample.cor = cor(t(fracs_time_all_ind) , m="s")

lc2 = unique(cbind(metadata$Sex[filt1], metadata$long.COVID[filt1], metadata$Demuxlet_Individual_Assignment[filt1]))
mmm  = match(rownames(fracs_time_4), lc2[,3] )  
lc_all2 = rep( lc2[mmm,1], 3)


col_lc = c("blue", "red")[(as.numeric(as.factor(lc_all)))] 
col_indv = turbo(20)[as.numeric(as.factor(rep(rownames(fracs_time_4),3)))]
col_lc2 = colsex[1:2][(as.numeric(as.factor(lc_all2)))] 


heatmap.3(sample.cor  , ColSideCol = c("blue", "red")[(as.numeric(as.factor(lc_all)))]  )

heatmap.3( sample.cor , 
           ColSideCol =  col_lc, 
           RowSideCol = col_lc2 )
ff = c(1,7,11,19)
heatmap.3( sample.cor[-ff,-ff] , 
           ColSideCol =  col_lc[-ff], 
           RowSideCol = col_lc2[-ff] )


par(mfrow=c(3,1))
barplot( t(fracs_time_4[oo,]) , col= colpals[m,3], main="4 months")
abline(v = 12.1, col=1, lwd=1, lty=3)
barplot( t(fracs_time_8[oo,]) , col= colpals[m,3], main="24 months")
abline(v = 12.1, col=1, lwd=1, lty=3)
barplot( t(fracs_time_24[oo,]) , col= colpals[m,3], main="8 months")
abline(v = 12.1, col=1, lwd=1, lty=3)


## L2
props_lc =  propeller(clusters=metadata$predicted.celltype.l2[filt1], sample=metadata$Demuxlet_Individual_Assignment[filt1], group=metadata$long.COVID[filt1])
props_tm =  propeller(clusters=metadata$predicted.celltype.l2[filt1], sample=metadata$orig.ident[filt1], group=metadata$timepoint[filt1])
filt = filt1 & metadata$long.COVID=="Yes"
props_tm_lc =  propeller(clusters=metadata$predicted.celltype.l2[filt], sample=metadata$orig.ident[filt], group=metadata$timepoint[filt])
filt = filt1 & metadata$long.COVID=="No"
props_tm_nc =  propeller(clusters=metadata$predicted.celltype.l2[filt], sample=metadata$orig.ident[filt], group=metadata$timepoint[filt])
temp1 = paste(cbind(lc, 1:20)[mm,3] , rownames(fracs_time_24))
temp11 = (1:20)[mm]
temp111 = rep(temp11, 3)
temp2 = cbind(temp111,  unlist(lapply(1:3, function(i) rep(i,20)) ) ) 
o = order(temp2[,1], temp2[,2])
bp = barplot( t(fracs_time_all_ind[o,]) , col= colpals[m,3], border=NA)
mat = matrix(bp, ncol=3, byrow=T)
abline(v = (mat[-1,1] + mat[-20,3] )/ 2  , col=2)


filt_extra = filt1 & metadata$predicted.celltype.l2 != "Eryth"
props_lc_ext =  propeller(clusters=metadata$predicted.celltype.l2[filt_extra], sample=metadata$Demuxlet_Individual_Assignment[filt_extra], group=metadata$long.COVID[filt_extra])

filt_extra = filt1 & metadata$predicted.celltype.l2 != "Eryth"  
props_tm_extra =  propeller(clusters=metadata$predicted.celltype.l2[filt_extra], sample=metadata$orig.ident[filt_extra], group=metadata$timepoint[filt_extra])

filt_extra = filt1 & metadata$long.COVID=="Yes" & metadata$predicted.celltype.l2 != "Eryth"  
props_tm_lc_extra =  propeller(clusters=metadata$predicted.celltype.l2[filt_extra], sample=metadata$orig.ident[filt_extra], group=metadata$timepoint[filt_extra])

filt_extra = filt1 & metadata$long.COVID=="No"  & metadata$predicted.celltype.l2 != "Eryth"  
props_tm_nc_extra =  propeller(clusters=metadata$predicted.celltype.l2[filt_extra], sample=metadata$orig.ident[filt_extra], group=metadata$timepoint[filt_extra])


 
filt_t24 = metadata$timepoint == "24months"
filt_t8 = metadata$timepoint == "8months"
filt_t4 = metadata$timepoint == "4months"

filt_extra = filt1 & filt_t24
props_lc_24 =  propeller(clusters=metadata$predicted.celltype.l2[filt_extra], sample=metadata$Demuxlet_Individual_Assignment[filt_extra], group=metadata$long.COVID[filt_extra])

filt_extra = filt1 & filt_t4
props_lc_4 =  propeller(clusters=metadata$predicted.celltype.l2[filt_extra], sample=metadata$Demuxlet_Individual_Assignment[filt_extra], group=metadata$long.COVID[filt_extra])

filt_extra = filt1 & filt_t8
props_lc_8 =  propeller(clusters=metadata$predicted.celltype.l2[filt_extra], sample=metadata$Demuxlet_Individual_Assignment[filt_extra], group=metadata$long.COVID[filt_extra])



## ??  
fracs_all = read.csv("C:/Users/61435/OneDrive - UNSW/lab/papers/longcovid/props_cell_ypes.csv")
mc = match(fracs_all[3:32,1], colpals[,2])

par(mfrow=c(1,2))
f_col = fracs_all[1,]  == "Joint" & fracs_all[2,] == "LC"
plot(0,0, xlim=c(1,5), ylim=c(0,0.4), col=0, main="LC", xlab="Timepoint", ylab="Proportion", axes=F)
sapply(2:4, function(i) points( rep(i,30), fracs_all[3:32,f_col][,i], pch=19 , col=colpals[mc,3]) )
sapply(1:30, function(j) lines( 2:4, fracs_all[3:32,f_col][j,2:4], pch=19 ,  col=colpals[mc,3][j]) )
axis(2)

f_col = fracs_all[1,]  == "Joint" & fracs_all[2,] == "non-LC"
plot(0,0, xlim=c(1,5), ylim=c(0,0.4), col=0, main="non-LC", xlab="Timepoint",ylab="Proportion", axes=F)
sapply(2:4, function(i) points( rep(i,30), fracs_all[3:32,f_col][,i], pch=19,  col=colpals[mc,3] ) )
sapply(1:30, function(j) lines( 2:4, fracs_all[3:32,f_col][j,2:4], pch=19,  col=colpals[mc,3][j] ) )
axis(2)


### 

par(mfrow=c(1,2))
f_col = fracs_all[1,]  == "Joint" & fracs_all[2,] == "LC"
plot(0,0, xlim=c(1,5), ylim=c(-5,0), col=0, main="LC", xlab="Timepoint", ylab="Proportion (log10)", axes=F)
sapply(2:4, function(i) points( rep(i,30), log10(as.numeric(fracs_all[3:32,f_col][,i])), pch=19 , col=colpals[mc,3]) )
sapply(1:30, function(j) lines( 2:4, log10(as.numeric(fracs_all[3:32,f_col][j,2:4])), pch=19 ,  col=colpals[mc,3][j]) )
axis(2 ,at = -5:0, lab= 10^(-5:0) )
axis(1, at = 2:4, lab=c(4,8,24))
f_col = fracs_all[1,]  == "Joint" & fracs_all[2,] == "non-LC"
plot(0,0, xlim=c(1,5), ylim=c(-5,0), col=0, main="non-LC", xlab="Timepoint",ylab="Proportion (log10)", axes=F)
sapply(2:4, function(i) points( rep(i,30), log10(as.numeric(fracs_all[3:32,f_col][,i])), pch=19,  col=colpals[mc,3] ) )
sapply(1:30, function(j) lines( 2:4, log10(as.numeric(fracs_all[3:32,f_col][j,2:4])), pch=19,  col=colpals[mc,3][j] ) )
axis(2 ,at = -5:0, lab= 10^(-5:0) )
axis(1, at = 2:4, lab=c(4,8,24))

